<?php
/**
 *
 * Auther: heyu
 * DateTime: 2020-01-03 15:03
 *
 */

namespace kwy\wechatapi\pay;


use kwy\util\http\CurlHttp;

class ApiRequest
{

    /** @var CurlHttp $http */
    private $http;

    /**
     * @return CurlHttp
     */
    public function getHttp(): CurlHttp
    {
        if (empty($this->http)){
            $this->http = new CurlHttp();
        }
        return $this->http;
    }

    /**
     * @param CurlHttp $http
     */
    public function setHttp(CurlHttp $http)
    {
        $this->http = $http;
    }
    /** @var Config $config */
    private $config;

    /**
     * @return Config
     */
    public function getConfig(): Config
    {
        return $this->config;
    }

    protected function toXml($params){
        $xml='<xml>';
        foreach ($params as $k=>$v){
            $xml.='<'.$k.'>'.$v.'</'.$k.'>';
        }
        $xml.='</xml>';
        return $xml;
    }

    protected function getNonceStr($len=32){
        $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        $str ="";
        for ( $i = 0; $i < $len; $i++ )  {
            $str.= substr($chars, mt_rand(0, strlen($chars)-1), 1);
        }
        return $str;
    }

    /**
     * @param Config $config
     */
    public function setConfig(Config $config)
    {
        $this->config = $config;
    }
    protected function call($method,$data){
        if (empty($this->http)){
            $this->http = new CurlHttp();
        }
        $url=Config::GATE_WAY.'?charset=utf-8';

        $this->http->setUrl($url);
        $params=[
            'app_id'=>$this->config->app_id,
            'method'=>$method,
            'charset'=>'utf-8',
            'sign_type'=>'RSA2',
            'timestamp'=>date('Y-m-d H:i:s'),
            'version'=>'1.0',
            'biz_content'=>json_encode($data),
        ];
        $params['sign']=$this->getSign($params);
        $this->http->setResponseType('array');
        return $this->http->post($params);
    }

    protected function getSign($params,$key){
        $str='';
        ksort($params);
        foreach ($params as $k=>$v){
            $str.=$k.'='.$v.'&';
        }
        $str .= 'key='.$key;

        return strtoupper(md5($str));
    }
}